package bus

import (
	"context"
	"pay/db"
	"pay/db/repo"
	"pay/utils"

	"github.com/nats-io/nats.go"
	"go.mongodb.org/mongo-driver/bson/primitive"
	"infish.cn/comm"
	"infish.cn/comm/pay"
)

// 创建订单退款申请
func PayRefundCreate() *comm.NatsMsgReplyer {
	refund := pay.ReFund{}
	utils.ConsoleFormat(pay.PayRefundCreateApi)
	return &comm.NatsMsgReplyer{
		Subject: pay.PayRefundCreateApi,
		Entity:  func() interface{} { return &refund },
		Cb2: func(_ *nats.Msg, entity interface{}) (interface{}, error) {
			refund := entity.(*pay.ReFund)
			ctx := context.Background()
			res, err := createRefund(ctx, refund)
			return res, err
		},
	}
}

func createRefund(ctx context.Context, refund *pay.ReFund) (id primitive.ObjectID, err error) {
	_id, err := repo.RepoAddDoc(&repo.RepoSession{Ctx: ctx, Client: db.GMongoDb}, repo.CollectionRefund, &refund)
	if err != nil {
		return primitive.NilObjectID, err
	}
	id, err = primitive.ObjectIDFromHex(_id)
	return
}
